'Soundex.bas    Ray Thomas      August 2000

'A simple Soundex calculator

'*** Get the word to calculate the soundex code for

CLS
LOCATE 5, 10
PRINT "Please type the word to create the soundex code for"
LOCATE 7, 20
LINE INPUT ; UserWord$

'*** To make processing simpler uppercase the input word
NewText$ = UCASE$(UserWord$)

'*** Keep the first letter for later
InitLet$ = LEFT$(NewText$, 1)

'*** Substitute the letters for numbers

TestWord$ = ""
FOR Counter = 1 TO LEN(NewText$)
        Char$ = MID$(NewText$, Counter, 1)
        IF INSTR("BFPV", Char$) THEN Char$ = "1"
        IF INSTR("CGJKQSXZ", Char$) THEN Char$ = "2"
        IF INSTR("DT", Char$) THEN Char$ = "3"
        IF INSTR("L", Char$) THEN Char$ = "4"
        IF INSTR("MN", Char$) THEN Char$ = "5"
        IF INSTR("R", Char$) THEN Char$ = "6"
        TestWord$ = TestWord$ + Char$
NEXT Counter

' *** Strip out the letters H and W
NewText$ = ""
FOR Counter = 1 TO LEN(TestWord$)
        Char$ = MID$(TestWord$, Counter, 1)
        Number = INSTR("HW", Char$)
        IF Number < 1 THEN NewText$ = NewText$ + Char$
NEXT Counter

'*** Check that no two adjacent codes are the same

TestWord$ = ""
FOR Counter = 1 TO LEN(NewText$)
        Char$ = MID$(NewText$, Counter, 1)
        IF Char$ <> RIGHT$(TestWord$, 1) THEN
                TestWord$ = TestWord$ + Char$
        END IF
NEXT Counter

'*** Strip out any non-alphabetic characters, vowels and Y

NewText$ = ""
FOR Counter = 1 TO LEN(TestWord$)
        Char$ = MID$(TestWord$, Counter, 1)
        Number = INSTR("123456", Char$)
        IF Number > 0 THEN NewText$ = NewText$ + Char$
NEXT Counter

'*** Create the final code

Number = INSTR("BCDFGJKLMNPQRSTVXZ", InitLet$)
IF Number > 0 THEN
        Soundex$ = InitLet$ + MID$(NewText$, 2, 3)
ELSE
        Soundex$ = InitLet$ + MID$(NewText$, 1, 3)
END IF

'*** If less than four characters pad right with "0"s
IF LEN(Soundex$) < 4 THEN
        Soundex$ = Soundex$ + STRING$(4 - LEN(Soundex$), "0")
END IF

LOCATE 10, 10
PRINT "The Soundex code for this word is :-"
LOCATE 12, 30
PRINT Soundex$
END

